\nocite{knmi:swbo:highleveldescription}
\nocite{knmi:swbo:datasources}
\nocite{knmi:swbo:usermanual}

\section{Architectural Representation}

[This section describes what software architecture is for the current system, and how it is represented. Of the Use-Case, Logical, Process, Deployment, and Implementation Views, it enumerates the views that are necessary, and for each view, explains what types of model elements it contains.]

\section{Architectural Goals and Constraints}

[This section describes the software requirements and objectives that have some significant impact on the architecture; for example, safety, security, privacy, use of an off-the-shelf product, portability, distribution, and reuse. It also captures the special constraints that may apply: design and implementation strategy, development tools, team structure, schedule, legacy code, and so on.] \\

\noindent The Space Weather back-office software shall be run on any workstation or pc that has python3 installed. It shall be possible to install additional python packages or to have them installed. \\

\noindent The software shall store and visualize open data and proprietary data. Access to proprietary data shall only be available with the KNMI enviroment (behind KNMI firewall). The software shall not implement user authentication. \\

\noindent It shall be possible to deploy multiple instances of the Space Weather back-office software. Each instance of the Space Weather back-office software shall store its own data. There is no need to make the data accessible for other instances of the back-off software. This simplifies the interface of the Space Weather back-office software.

\section{Use-Case View}

[This section lists use cases or scenarios from the use-case model if they represent some significant, central functionality of the final system, or if they have a large architectural coverage—they exercise many architectural elements or if they stress or illustrate a specific, delicate point of the architecture.] \\

\noindent The SWBO use cases follow directly from the purpose of the software (see \cite{knmi:swbo:highleveldescription}):

\begin{itemize}
\item Visualisation for real-time monitoring
\item Visualisation for space weather training and research
\item Library for space weather data research in Python
\item External presentation
\item Research to operations
\end{itemize}

\subsection{Use-Case Realizations}

[This section illustrates how the software actually works by giving a few selected use-case (or scenario) realizations, and explains how the various design model elements contribute to their functionality.] 

\subsubsection{Visualisation for real-time monitoring}

\begin{enumerate}
\item Client selects time series parameter and time range 
\item Software checks if data is available in store and retrieves from external source if not
\item Software shows plot of data
\item Periodically client updates the time range and repeat from step 2
\end{enumerate}

\subsubsection{Visualisation for space weather training and research}

\begin{enumerate}
\item User selects time series parameter and time range 
\item Software checks if data is available in store and retrieves from external source if not
\item Software shows plot of data
\item User can update the time range to browse, zoom in or zoom out
\item Software checks if data is available in store and retrieves from external source if not
\item Software shows updated plot of data
\item Until user stops session repeat from step 4
\end{enumerate}

\section{Logical View}

[This section describes the architecturally significant parts of the design model, such as its decomposition into subsystems and packages. And for each significant package, its decomposition into classes and class utilities. You should introduce architecturally significant classes and describe their responsibilities, as well as a few very important relationships, operations, and attributes.]

\subsection{Overview}

[This subsection describes the overall decomposition of the design model in terms of its package hierarchy and layers.]

\begin{center}
\includegraphics[width=\columnwidth]{figures/space_weather.png}%
\end{center}

\subsection{Architecturally Significant Design Packages}

[For each significant package, include a subsection with its name, its brief description, and a diagram with all significant classes and packages contained within the package. 
For each significant class in the package, include its name, brief description, and, optionally, a description of some of its major responsibilities, operations, and attributes.]

\subsubsection{Data Store}

The data store stores the space weather data. Time series have a simple table structure that can stored in an SQL database.
The database that shall be used is SQLite \cite{knmi:swbo:sqlite}. It is integrated in Python3 via the sqlite3 interface module and has enough functionallity and performance to store many years of Space Weather time series data.
The data store also contains a set of modules to retrieve data from external sources.

\subsubsection{Data Viewer Back-end}

The data viewer back-end software provides the interface between the data store and the web server.

\subsubsection{Data Viewer Front-end}

The data viewer front-end software shall exist of HTML pages and JavaScript (JS) code.
Suitable JavaScript frameworks and libraries shall be used.

\subsubsection{Web Server}

A standard web server. The initial choice is to use Flask.
Flask is a lightweight Web Server Gateway Interface (WSGI) web application framework. It is designed to make getting started quick and easy, with the ability to scale up to complex applications \cite{knmi:swbo:flask}.

\subsubsection{Web Browser}

A standard web browser, such as Google Chrome, Mozilla Firefox or Apple Safari, shall be used to interact with the end user.
The web browser must be compatible with the Data Viewer Front-end software.

\section{Process View}

[This section describes the system's decomposition into lightweight processes (single threads of control) and heavyweight processes (groupings of lightweight processes). Organize the section by groups of processes that communicate or interact. Describe the main modes of communication between processes, such as message passing, interrupts, and rendezvous.]

\section{Deployment View}

[This section describes one or more physical network (hardware) configurations on which the software is deployed and run. It is a view of the Deployment Model. At a minimum for each configuration it should indicate the physical nodes (computers, CPUs) that execute the software and their interconnections (bus, LAN, point-to-point, and so on.) Also include a mapping of the processes of the Process View onto the physical nodes.]

\section{Implementation View}

[This section describes the overall structure of the implementation model, the decomposition of the software into layers and subsystems in the implementation model, and any architecturally significant components.]

\subsection{Overview}

[This subsection names and defines the various layers and their contents, the rules that govern the inclusion to a given layer, and the boundaries between layers. Include a component diagram that shows the relations between layers. ]

\subsection{Layers}

[For each layer, include a subsection with its name, an enumeration of the subsystems located in the layer, and a component diagram.]

\section{Data View}

[A description of the persistent data storage perspective of the system. This section is optional if there is little or no persistent data, or the translation between the Design Model and the Data Model is trivial.] \\

\noindent A list of sources of space weather data that could/should be ingested by the back-office tool is listed in \cite{knmi:swbo:datasources}. 

\subsection{Time Series}

\noindent The initial focus is on time series of the magnetic field, solar wind and the kp index.
The highest time resolution that will be used is in order of minutes for magnatic field and solar wind data, and 3 hours for the kp index.
To be able to quickly retrieve data of larger periods, up to several years, data is not only stored at the highest time resolution, but also at lower resolutions.
The lower resolutions are made by averaging the high resolution data during ingestion of the hight resolution data.
Currently, the lower resolutions that are considered are 1 hour and 1 day time steps. \\

\noindent The time series data are simple tables with a time column and a few other colums for the parameters.

\noindent Table naming in the database:
\begin{verbatim}
<dataset>_<source>_<resolution>
\end{verbatim}

\noindent Times shall be stored in the format as recommended by SQLite:
\begin{verbatim}
YYYY-MM-DD HH:MM:SS
\end{verbatim}

\subsubsection{Geomagnetic Field}

\begin{tabular}{ll}
dataset name & mag \\
sources & dscovr, ace, nrt \\
resolutions & 1m, 1h, 1d \\
columns & \texttt{time TEXT NOT NULL UNIQUE} \\
& \texttt{bt REAL} \\
& \texttt{bx\_gsm REAL} \\
& \texttt{by\_gsm REAL} \\
& \texttt{bz\_gsm REAL} \\
\end{tabular}

% time text not null unique,bt real,bx_gsm real,by_gsm real,bz_gsm real

\subsubsection{Solar Wind}

\begin{tabular}{ll}
dataset name & wind \\
sources & dscovr, ace, nrt \\
resolutions & 1m, 1h, 1d \\
columns & \texttt{time TEXT NOT NULL UNIQUE} \\
& \texttt{proton\_density REAL} \\
& \texttt{proton\_speed REAL} \\
& \texttt{proton\_pressure REAL} \\
& \texttt{proton\_temperature REAL} \\
\end{tabular}

\subsubsection{Kp Index}

\begin{tabular}{ll}
dataset name & kp \\
sources & gfz, mouk \\
resolutions & 3h, 1d \\
columns & \texttt{time TEXT NOT NULL UNIQUE} \\
& \texttt{kp REAL} \\
\end{tabular}

\section{Size and Performance} 

[A description of the major dimensioning characteristics of the software that impact the architecture, as well as the target performance constraints.]

\section{Quality}

[A description of how the software architecture contributes to all capabilities (other than functionality) of the system: extensibility, reliability, portability, and so on. If these characteristics have special significance, such as safety, security or privacy implications, they must be clearly delineated.]

